<?php
/**
 * WPSDFrontEndAction.
 * @author Dave Ligthart <info@daveligthart.com>
 * @version 0.1
 * @package wp-stats-dashboard
 */
class WPSDFrontEndAction extends WPSDWPPlugin{

	/**
	 * __construct()
	 * @param String $plugin_name
	 * @param String $plugin_base
	 */
	function WPSDFrontEndAction($plugin_name, $plugin_base){
		$this->plugin_name = $plugin_name;
		$this->plugin_base = $plugin_base;

		$this->add_action('wp_head');
	}
	
	function wpsd_create_nonce($action) {
		$nonce_life = 86400;
		
		return substr(wp_hash(ceil(time() / ( $nonce_life / 2 )) . $action, 'nonce'), -12, 10);
	}
	
	function wp_head(){
			
		wp_enqueue_script('jquery'); // use jquery.
	
		$nonce = $this->wpsd_create_nonce('wpsd-metrics-nonce');
		
		$this->render('header', array('version' => WPSD_VERSION, 'nonce' => $nonce));
	}

	function wp_footer() {
		$this->render('footer');
	}
}
?>