<?php 

if(!isset($_POST['_ajax_nonce'])) {
	
	require( dirname(__FILE__) . '/../../../../wp-load.php'); // wordpress context.
	
	global $current_user;
	
	if(!$current_user->caps['administrator'] && $_REQUEST['wpsd_update_cache']) {
		die(__('You need to be administrator to view this content', 'wpsd'));	
	}
}

if(!class_exists('Services_JSON')) {
	include_once('util/Services_JSON.php');
}

include_once('util/WPSDStats.php');
include_once('util/WPSDAlexaRank.php');
include_once('util/WPSDCompeteRank.php');
include_once('util/WPSDPageRank.php');
include_once('util/WPSDTechnoratiRank.php');
include_once('util/WPSDDeliciousRank.php');
include_once('util/WPSDGoogleSocialGraph.php');
include_once('util/WPSDYahooRank.php');
include_once('util/WPSDGoogleBackLinks.php');
include_once('util/WPSDMozRank.php');
include_once('util/WPSDPostRank.php');
include_once('util/WPSDDigg.php');
include_once('util/WPSDSiteAge.php');
include_once('util/WPSDSiteValue.php');
include_once('util/WPSDEngagement.php');
include_once('util/WPSDTweetMeme.php');
include_once('util/WPSDReddit.php');
include_once('util/WPSDBacktype.php');

/**
 * Load stats.
 * @access private
 */
function wpsd_load_stats() {
	ob_start();
	
	// Get engagement.
	$eng = new WPSDEngagement();

	// Get google pagerank.
	$pr = new WPSDPageRank();

	// Backlinks.
	$bl = new WPSDGoogleBackLinks(get_bloginfo('url'), true);
	$inbound = $bl->getRank();

	// Get google social graph in out xfn relations.
	$gsg = new WPSDGoogleSocialGraph(get_bloginfo('url'));

	// Get alexa rank.
	$alexa = new WPSDAlexaRank(get_bloginfo('url'), true); //get alexa traffic rank.

	// Get technorati rank.
	$tr = new WPSDTechnoratiRank(get_bloginfo('url'), true); // get technorati rank.

	// Get delicious linksin.
	$ds = new WPSDDeliciousRank(get_bloginfo('url'), true); // get number of delicious bookmarks.

	// Get compete.com rank.
	$cc = new WPSDCompeteRank(get_bloginfo('url'), true); // get compete.com rank.

	// Get yahoo inbound.
	$yi = new WPSDYahooRank(get_bloginfo('url'), true);

	// Get Moz Rank.
	$mr = new WPSDMozRank();

	// Get Post Rank.
	$postrank = new WPSDPostRank();

	// Digg.
	$digg = new WPSDDigg(get_bloginfo('url'), true);

	// Tweets.
	$tm = new WPSDTweetMeme(get_bloginfo('url'), true);

	// Age.
	$siteage = new WPSDSiteAge(get_bloginfo('url'));
	$age = $siteage->getAge(get_bloginfo('url'));

	// Value.
	$sitevalue = new WPSDSiteValue($age, 1.2, $inbound);
	
	// Reddit score, comments.
	$reddit = new WPSDReddit(get_bloginfo('url'), true);
	
	// Backtype.
	$bt = new WPSDBacktype(get_bloginfo('url'), true);
	
	if(isset($_POST['_ajax_nonce'])) {
?>		
	<style type="text/css">
	#wpsd-overview-table, #wpsd-overview-table td, #wpsd-overview-table tr, #wpsd-overview-table td span {
		border:0 solid black;
		font-family: inherit;
		font-size: 12px;
		font-weight:inherit;
		margin:0;
		padding:0;
	}
	</style>
<?php 		
		
		echo '<table id="wpsd-overview-table" border="0" style="width:100%;">';
		
	} else {

		echo '<style type="text/css">#wpsd-overview-table, #wpsd-overview-table td, #wpsd-overview-table tr {border:0px solid black; margin:0;padding:0;}#wpsd-overview-table img {width:23px;}</style>';
	
		echo '<h4 class="heading">General Social Metrics</h4>';
	
		echo '<table id="wpsd-overview-table" border="0" style="border-top: 1px solid #CCC; width:100%;">';
	}
	
	wpsd_helper_add_row('feed', '<span>Engagement:</span>', $eng->getEngagement(),1);

	wpsd_helper_add_row('pr', 	'<span>PageRank:</span>', sprintf('<a href="http://www.google.com/technology/pigeonrank.html" title="pigeonrank tm" target="_blank" rel="nofollow">%d</a> / %d', $pr->getPagerank(), 10), 2 );
	
	wpsd_helper_add_row('pr', 	'<span>Backlinks:</span>', sprintf('<a href="%s" title="google backlinks" target="_blank" rel="nofollow">%s</a>' ,$bl->getAddress(), $inbound),1 );
	
	wpsd_helper_add_row('pr', 	'<span>Social Graph:</span>', sprintf('<a href="%s" title="google social graph relations incoming and outgoing" target="_blank" rel="nofollow">%d | %d</a>', $gsg->getHomeAddress(), $gsg->getNodeInCount(), $gsg->getNodeOutCount() ),2 );

	wpsd_helper_add_row('alexa','<span>Alexa:</span>', sprintf('<a href="http://www.alexa.com/data/details/traffic_details/%s" title="alexa details" target="_blank" rel="nofollow">%s | %d</a>', get_bloginfo('url'), $alexa->getRank(), $alexa->getLinksIn() ),1 );

	wpsd_helper_add_row('tr', 	'<span>Technorati:</span>', sprintf('<a href="%s" title="technorati details" target="_blank" rel="nofollow">%s</a>', $tr->getAddress(), $tr->getRank() ),2 );

	wpsd_helper_add_row('ds', 	'<span>Del.icio.us:</span>', sprintf('<a href="%s" title="del.icio.us details" target="_blank" rel="nofollow">%s</a>', $ds->getHomeAddress(), $ds->getLinksIn() ),1 );

	wpsd_helper_add_row('cc', 	'<span>Compete:</span>', sprintf('<a href="%s" title="compete.com details" target="_blank" rel="nofollow">%s | %s</a>', $cc->getHomeAddress(), $cc->getRank(), $cc->getLinksIn() ),2 );

	wpsd_helper_add_row('yahoo','<span>Yahoo:</span>', sprintf('<a href="%s" title="yahoo details" target="_blank" rel="nofollow">%s</a>', $yi->getHomeAddress(), $yi->getLinksIn() ),1 );

	wpsd_helper_add_row('moz', 	'<span>MozRank:</span>', sprintf('<a href="%s" title="mozrank details" target="_blank" rel="nofollow">%s</a> / %d', $mr->getHomeAddress(), $mr->mozRank(get_bloginfo('url') ), 10 ), 2 );

	wpsd_helper_add_row('ptr', 	'<span>PostRank:</span>', sprintf('<a href="%s" title="postrank details" target="_blank" rel="nofollow">%s</a> / %d',$postrank->getHomeAddress(), $postrank->getPostRank(get_bloginfo('url')), 10 ),1 );

	wpsd_helper_add_row('digg', '<span>Digg:</span>', sprintf('<a href="%s" title="digg details" target="_blank" rel="nofollow">%s</a>', $digg->getAddress(), $digg->getRank()),2 );

	wpsd_helper_add_row('tw', 	'<span>Tweets:</span>', sprintf('<a href="%s" title="tweets" target="_blank" rel="nofollow">%s</a>',$tm->getAddress(), $tm->getCount()),1);
	
	wpsd_helper_add_row('rd',   '<span>Reddit:</span>', sprintf('<a href="%s" title="tweets" target="_blank" rel="nofollow">%d | %d</a>', $reddit->getHomeAddress(), $reddit->getRank() , $reddit->getComments()) , 2);
	
	wpsd_helper_add_row('bt',   '<span>Backtype:</span>', sprintf('<a href="%s" title="backtype" target="_blank" rel="nofollow">%d | %d</a>', $bt->getHomeAddress(), $bt->getComments(), $bt->getTweets()) , 2);
	
	wpsd_helper_add_row('age', 	'<span>Site age:</span>', '<a href="'.$siteage->getAddress().'" title="whois" target="_blank" rel="nofollow">' . number_format($age, 4) . '</a>',1);

	wpsd_helper_add_row('est', 	'<span>Estimated:</span> ', $sitevalue->getValue(), 2);
	
	echo '</table>';
		
	if(date('Y-m-d') != get_option('wpsd_cache_date')) {
		update_option('wpsd_cache_date', date('Y-m-d'));
	}

	ob_end_flush();
}

function wpsd_helper_add_row($icon, $html1, $html2, $i) {
	?>
<tr>
	<td><?php echo '<img src="'. WPSD_PLUGIN_URL . '/resources/images/icons/'.$icon.'.png" alt="'.$icon.' icon" />'; ?></td>
	<td<?php echo ($i % 2 == 0)?' class="alternate"':'';?>><?php echo $html1; ?></td>
	<td<?php echo ($i % 2 == 0)?' class="alternate"':'';?>><?php echo $html2; ?></td>
</tr>
	<?php
}

// Start loading.
wpsd_load_stats();

exit;
?>