<?php
/**
 * WPSDCompeteDashboardWidget.
 *
 * Display the UV graph from Compete.com.
 *
 * @author dligthart <info@daveligthart.com>
 * @version 0.3
 * @package wp-stats-dashboard
 */
class WPSDCompeteDashboardWidget{

	/**
	 * Constructor.
	 * @access public
	 */
	function WPSDCompeteDashboardWidget() {
		add_action( 'wp_dashboard_setup', array(&$this, 'register_widget') );
		add_filter( 'wp_dashboard_widgets', array(&$this, 'add_widget') );
	}

	/**
	 * Register widget.
	 * @access protected
	 */
	function register_widget() {
		wp_register_sidebar_widget('wpsd_compete', 'Stats - Compete.com',
			array(&$this, 'widget'),
			array(
			'all_link' => '',
			'feed_link' => '',
			'edit_link' => 'options.php' )
		);
	}

	/**
	 * Add widget.
	 * @param array $widgets
	 * @access protected
	 */
	function add_widget( $widgets ) {
		global $wp_registered_widgets;

		if ( !isset($wp_registered_widgets['wpsd_compete']) ) return $widgets;

		array_splice( $widgets, 2, 0,'wpsd_compete');

		return $widgets;
	}

	/**
	 * Widget.
	 */
	function widget($args = array()) {
		if (is_array($args))
			extract( $args, EXTR_SKIP );

		echo $before_widget.$before_title.$widget_name.$after_title;

		$form = new WPSDAdminConfigForm();

		if($form->getWpsdWidgetCompete()) {

			$domain = str_replace('http://', '', get_bloginfo('url'));
			$domain = str_replace('https://', '', $domain);
			$domain = str_replace('www.', '', $domain);

			ob_start();

			echo '<!-- WP-Stats-Dashboard - START Compete.com -->';

			echo '<img src="http://home.compete.com.edgesuite.net/'.$domain.'++++_uv.png" alt="compete.com graph" width="100%" />';

			echo '<!-- WP-Stats-Dashboard - STOP Compete.com-->';

			ob_end_flush();
		} else {
			_e('Widget disabled check', 'wpstatsdashboard'); echo ' <a href="' . wpsd_get_settings_url() .'" title="wp-stats-dashboard settings" target="_self">'.__('settings', 'wpstatsdashboard') . '</a>';
		}

		echo $after_widget;
	}
}
?>