<?php
/**
 * WPSDGoogleBackLinks.
 * @author dligthart <info@daveligthart.com>
 * @version 0.1
 * @package wp-stats-dashboard
 */
class WPSDGoogleBackLinks extends WPSDStats {

	var $xml;
	var $values;
	var $address = '';

	/**
	 * WPSDGoogleBackLinks.
	 * @param string $domain
	 * @param boolean $curl
	 */
	function WPSDGoogleBackLinks($domain, $curl = false) {
		parent::WPSDStats();
		
		if($this->isOutdated()) {
			
			$this->values['rank'] = $this->getBackLinks($domain);
			
			$this->set_cache('google_bl', $this->values['rank']);
			
		} else {
			
			$this->values['rank'] = $this->get_cache('google_bl');
		}
	}

	/**
	 * Get data from alexa.
	 * @param string $domain
	 * @access public
	 */
	function get_data($domain) {
		$url = $this->address;
		$xml = file_get_contents($url);
		return $xml;
	}

	/**
	 * Set data.
	 */
	function set() {
		
	}

	/**
	 * Get data.
	 * @return value
	 * @access protected
	 */
	function get($value){
		return (isset($this->values[$value]) ? $this->values[$value] : '0');
	}

	/**
	 * Get rank.
	 * @return rank
	 * @access public
	 */
	function getRank() {
		return $this->get('rank');
	}

	/**
	 * Get address.
	 * @return address
	 * @access public
	 */
	function getAddress() {
		return $this->address;
	}
	
	/**
	 * Get google backlinks.
	 *
	 * @param unknown_type $uri
	 * @return integer
	 */
	function getBackLinks($uri) {
	    $uri = trim(eregi_replace('http://', '', $uri)); $uri = trim(eregi_replace('http', '', $uri));
	    $url = 'http://www.google.com/search?hl=en&lr=&ie=UTF-8&q=link:'.$uri.'&filter=0';
	    $this->address = $url;
	    $v = $this->get_data_curl('');
	    preg_match('/of about \<b\>(.*?)\<\/b\>/si',$v,$r);
	    preg_match('/of \<b\>(.*?)\<\/b\>/si',$v,$s);
	    if ($s[1]!=0) {
	        return $s[1];
	    } else {
	        return ($r[1]) ? $r[1] : '0';
	    }
	}
	
	/**
	 * Get data by curl.
	 * @param string $domain
	 * @access public
	 */
	function get_data_curl($domain) {
		$xml = '';
		if(function_exists('curl_init')) {
			$url = $this->address;
			ob_start();
			$ch = curl_init();
			$timeout = 5;
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6");
			$xml = curl_exec($ch);
			curl_close($ch);
			ob_end_clean();
		}
		return $xml;
	}
}
?>