<?php
/**
 * WPSDSiteValue.
 * @author dligthart <info@daveligthart.com>
 * @version 0.1
 * @package wp-stats-dashboard
 */
class WPSDSiteValue extends WPSDStats {

	var $value;

	function WPSDSiteValue($age_years = 1, $inbound = 1, $cpm = 1.2) {
		parent::WPSDStats();
		
		if($this->isOutdated()) {
			$totalhits = $this->getTotalHits();
			
			$rev_month = (($totalhits / $age_years / 12) / 1000) * $cpm;
			
			$this->value = round(($rev_month * $inbound * 12), 2);
			
			if(null == $this->value) $this->value = '-';
			
			$this->set_cache('site_value', $this->value);
			
		} else {
			
			$this->value = $this->get_cache('site_value');	
		}
	}

	function getValue() {
		return $this->value;
	}

	function getTotalHits() {
		
		$result =  wpsd_read_cache();
		
		preg_match("@Total views:</span>(.*?)</p>@si", $result, $matches);
		
		$n  = str_replace(",", "", trim( $matches[1] ));
		
		$total = $n;
		
		return $total;	
	}
}
?>