<?php
/**
 * WPSDMetricsWidget.
 * @author Dave Ligthart <info@daveligthart.com>
 * @version 0.1
 * @package wp-stats-dashboard
 */
class WPSDMetricsWidget extends WP_Widget {
	
	function __construct() {
		parent::__construct(false, __('WP-Stats-Dashboard: Social Metrics', 'wpsd'));
	}
	
	function WPSDMetricsWidget() {
		parent::WP_Widget(false, __('WP-Stats-Dashboard: Social Metrics', 'wpsd'));
	}

	/* (non-PHPdoc)
	 * @see wp-includes/WP_Widget#form($instance)
	 */
	function form($instance) {
		// outputs the options form on admin
		$title = esc_attr($instance['title']);
		$desc = esc_attr($instance['desc']);
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
       		
       		  <p><label for="<?php echo $this->get_field_id('desc'); ?>"><?php _e('Description:'); ?> <textarea class="widefat" id="<?php echo $this->get_field_id('desc'); ?>" name="<?php echo $this->get_field_name('desc'); ?>" type="text"><?php echo $desc; ?></textarea></label></p>
        <?php 
	}

	/* (non-PHPdoc)
	 * @see wp-includes/WP_Widget#update($new_instance, $old_instance)
	 */
	function update($new_instance, $old_instance) {
		// processes widget options to be saved
		return $new_instance;
	}

	/* (non-PHPdoc)
	 * @see wp-includes/WP_Widget#widget($args, $instance)
	 */
	function widget($args, $instance) {
		extract( $args );
        $title = apply_filters('widget_title', $instance['title']);
        
        $desc = $instance['desc'];
?>
        <?php echo $before_widget; ?>
        <!-- wp-stats-dashboard widget by http://daveligthart.com -->
        <div id="wpsd-metrics-widget">
      
        <?php if ( $title ) { echo $before_title . $title . $after_title; } ?>
                         
          	<p><?php echo $desc; ?></p>
									
			<div id="wpsd-metrics-data" align="center" style="margin:0px;"></div>			
						
		</div>
		<!-- wp-stats-dashboard widget by http://daveligthart.com -->			
        <?php echo $after_widget; ?>
        
<?php
	}
}
add_action('widgets_init', create_function('', 'return register_widget("WPSDMetricsWidget");'));
?>