<?php
/**
 * Admin config template.
 * @author dligthart <info@daveligthart.com>
 * @version 0.3
 * @package wp-stats-dashboard
 */
$cache_path = dirname(__FILE__) . '/../../../../cache/';

$checked = ' checked="checked"';

?>
<?php
// Security.
$user = wp_get_current_user();
if($user->caps['administrator']):
?>
<div class="wrap">
	<h2><?php _e('WP-Stats-Dashboard Options','wpstatsdashboard');?></h2>

	<p>
		<?php if(!function_exists('curl_init')): ?>

		<strong><?php _e('CURL extension not installed:','wpstatsdashboard'); ?></strong>
		&nbsp;<?php _e('you must have CURL extension enabled in your php configuration','wpstatsdashboard');?>.
		<br/>

		<?php endif; ?>

		<?php if(!file_exists($cache_path)): ?>

		<strong><?php _e('wp-content/cache does not exist:','wpstatsdashboard');?></strong>
		&nbsp;<?php _e('please make sure that the "wp-content/cache" directory is created','wpstatsdashboard');?>.
		<br/>
		<p>
		<?php _e('please use your ftp browser to navigate to the "wp-content" folder and create a directory named "cache".', 'wpstatsdashboard'); ?>
		</p>
		<?php else: ?>

		<?php if(!is_writable($cache_path)): ?>

		<strong><?php _e('wp-content/cache is not writable:','wpstatsdashboard');?></strong>
		&nbsp;<?php _e('please make sure that the "wp-content/cache" directory is writable by webserver.','wpstatsdashboard');?>.
		<br/>
		<p>
		<?php _e('please use your ftp browser to navigate to the "wp-content" folder and change file permissions of the "cache" folder to 777.', 'wpstatsdashboard'); ?>
		</p>
		<?php endif; ?>
		
		<?php if('' == $form->getWpsdBlogId()): ?>
		
		<strong><?php _e('please install the wordpress.com stats plugin and follow the instructions it presents:','wpstatsdashboard');?></strong>
		<br/><a href="http://wordpress.org/extend/plugins/stats/" target="_blank">http://wordpress.org/extend/plugins/stats/</a>
		<?php endif;?>
		
		<?php endif; ?>
	</p>
	<?php if(file_exists($cache_path) && is_writable($cache_path)): ?>
	<br/>
	<form name="wpsd_config_form" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post" accept-charset="utf-8">
		<?php echo $form->htmlFormId(); ?>
		<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
				<tr>
					<th scope="row">
						<label for="wpsd_blog_id"><?php _e('Blog ID','wpstatsdashboard'); ?>:</label>
					</th>
					<td>
								<?php
								echo "<input type='text' size='60' ";
								echo "name='wpsd_blog_id' ";
								echo "id='wpsd_blog_id' ";
								echo "value='".$form->getWpsdBlogId()."'" .
										"/>\n";
								?><br/>
								<?php _e('Enter blog id. Please install the <a href="http://wordpress.org/extend/plugins/stats/" target="_blank">wordpress.com stats plugin</a> to find your blog-id.','wpstatsdashboard'); ?>
					</td>
				</tr>
				<tr>
					<th scope="row">
						<label for="wpsd_un"><?php _e('Username','wpstatsdashboard'); ?>:</label>
					</th>
					<td>
								<?php
								echo "<input type='text' size='60' ";
								echo "name='wpsd_un' ";
								echo "id='wpsd_un' ";
								echo "value='".$form->getWpsdUn()."'" .
										"/>\n";
								?><br/>
								<?php _e('Enter your WordPress.com username','wpstatsdashboard'); ?>
					</td>
				</tr>
				<tr>
					<th scope="row">
						<label for="wpsd_pw"><?php _e('Password','wpstatsdashboard'); ?>:</label>
					</th>
					<td>
								<?php
								echo "<input type='text' size='60' ";
								echo "name='wpsd_pw' ";
								echo "id='wpsd_pw' ";
								echo "value='".$form->getWpsdPw()."'" .
										"/>\n";
								?><br/>
								<?php _e('Enter your WordPress.com password','wpstatsdashboard'); ?>
					</td>
				</tr>
		
				<tr>
					<th scope="row" valign="top">
						<label><?php _e('Enabled / Disable <br/> Dashboard Widgets','wpstatsdashboard'); ?>:</label>
					</th>
					<td>
						<br/>
						<input type="checkbox" name="wpsd_widget_overview"<?php echo $form->getWpsdWidgetOverview() ? $checked : ''; ?> /> <?php _e('Stats - Overview', 'wpstatsdashboard'); ?>
						<br/>
						<input type="checkbox" name="wpsd_widget_postviews"<?php echo $form->getWpsdWidgetPostViews() ? $checked : ''; ?> /> <?php _e('Stats - Post views', 'wpstatsdashboard'); ?>
						<br/>
						<input type="checkbox" name="wpsd_widget_referrers"<?php echo $form->getWpsdWidgetReferrers() ? $checked : ''; ?> /> <?php _e('Stats - Referrers', 'wpstatsdashboard'); ?>
						<br/>
						<input type="checkbox" name="wpsd_widget_clicks"<?php echo $form->getWpsdWidgetClicks() ? $checked : ''; ?> /> <?php _e('Stats - Clicks', 'wpstatsdashboard'); ?>
						<br/>
						<input type="checkbox" name="wpsd_widget_searchterms"<?php echo $form->getWpsdWidgetSearchTerms() ? $checked : ''; ?> /> <?php _e('Stats - Search terms', 'wpstatsdashboard'); ?>
						<br/>
						<input type="checkbox" name="wpsd_widget_compete"<?php echo $form->getWpsdWidgetCompete() ? $checked : ''; ?> /> <?php _e('Stats - Compete.com', 'wpstatsdashboard'); ?>
						<br/>
					<?php /*	<input type="checkbox" name="wpsd_widget_dailyviews"<?php echo $form->getWpsdWidgetDailyViews() ? $checked : ''; ?> /> <?php _e('Stats - Daily views', 'wpstatsdashboard'); ?>
						<br/> */
					?>
					</td>
				</tr>
		</table>
		<p class="submit"><input type="submit" name="Submit" value="<?php _e('Save Changes','wpstatsdashboard'); ?>" />
		</p>
	</form>

	<?php endif; ?>

</div>

<?php if('' != $form->getWpsdUn() && '' != $form->getWpsdPw()
	&& file_exists($cache_path) && is_writable($cache_path)): ?>

<?php endif; ?>

<?php else: ?>
<strong><?php _e('As a user you have insufficient rights to view this configuration. Please contact your administrator.','wpstatsdashboard');?></strong>
<?php endif; ?>

<?php include_once('blocks/footer.php'); ?>
